//+------------------------------------------------------------------+
//|                                           FXA0 - Ladderv0.01.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""

extern double TakeProfit = 10;
double Lots = 0.1;
double InitialStop = 0;

extern int MaxTrades=3;
extern int PipStep=15;
extern int mm=0;  //money management, will add this later
extern int risk=12;  //only used if mm=1
int AccountType=0;  // 0 if Normal Lots, 1 for mini lots, 2 for micro lots
extern int MagicNumber = 888888; //added
extern int T_JRSX_period=14;

int ticket;
int marketQualityValue=0;
int  OpenOrders=0, cnt=0;
int  slippage=5;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int lastType=0;
bool ContinueOpening=True;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastPrice=0, LastLots=0;
double PipValue=0;
string text="", text2="";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| value added functions                                            |
//+------------------------------------------------------------------+


int marketQuality() 
{
   //marketQuality will help us determine strength in a direction, add multiple indicators that add quality points if going in a long direction and
   //subtract if going in a short direction
   
   //determines current direction, will need to add more intelligence to this
   //this determines if the 10poitns3 can go to work in a direction
   //may possible be multiple criteria for same entry direction, if there is they will need multiple criteria for close direction

	int QualityPoints=0;
	if( iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 0)>50 && iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 0)>iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 1)) { QualityPoints++; }
	//if(iRSI(NULL,0,21,PRICE_CLOSE,0)>50 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints++; }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)<50 && iRSI(NULL,0,21,PRICE_CLOSE,1)>50 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints++; }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)<60 && iRSI(NULL,0,21,PRICE_CLOSE,1)>60 && iRSI(NULL,0,21,PRICE_CLOSE,0)>iRSI(NULL,0,21,PRICE_CLOSE,1)){ QualityPoints++; }

	if( iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 0)<50 && iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 0)<iCustom(Symbol(), Period(), "Turbo_JRSX", T_JRSX_period, 0, 1)) { QualityPoints--; }
	//if(iRSI(NULL,0,21,PRICE_CLOSE,0)<50 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints--; }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)>50 && iRSI(NULL,0,21,PRICE_CLOSE,1)<50 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints--; }
	//if (iRSI(NULL,0,21,PRICE_CLOSE,2)>40 && iRSI(NULL,0,21,PRICE_CLOSE,1)<40 && iRSI(NULL,0,21,PRICE_CLOSE,0)<iRSI(NULL,0,21,PRICE_CLOSE,1)) { QualityPoints--; }
	
	return(QualityPoints);
}

void CloseAllOrders()
{
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	   if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {
         if (OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow); }
         if (OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow); }
         return(0);
      }
   }
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
   if (AccountType==0){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); } else { lotsi=Lots; } } 
   if (AccountType==1){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; } else { lotsi=Lots; } }
   if (AccountType==2){ if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/100; } else { lotsi=Lots; } }
   if (lotsi<0.01) lotsi=0.01;
   if (lotsi>100) lotsi=100; 
   
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=1; }
   
   //finds current profit on last opened order, last type of order and the total number of open orders
   lastType=0;
   OpenOrders=0; 
   Profit=0; LastTicket=0; LastPrice=0; LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
	  {			
	  	   LastTicket=OrderTicket();
			LastPrice=OrderOpenPrice();
			LastLots=OrderLots();
			if (OrderType()==OP_BUY) 
			{			
            Profit=OrderProfit();
            lastType=1;
			}
			if (OrderType()==OP_SELL) 
			{
            Profit=OrderProfit();
            lastType=2; 
  			}
  		   OpenOrders++; 
	  }
   }
   
   
   marketQualityValue=0;
   marketQualityValue=marketQuality();
   //close profitable orders
   if(Profit>=TakeProfit) { CloseAllOrders(); }  
   
   //close orders if market changes in opposite direction
   if(lastType==1 && marketQualityValue<0) { CloseAllOrders(); }
   if(lastType==2 && marketQualityValue>0) { CloseAllOrders(); }
   
      
   if (OpenOrders>=MaxTrades) 
   { ContinueOpening=False; } 
   else { ContinueOpening=True; }
   
   marketQualityValue=0;
   if(OpenOrders==0)
   {
      marketQualityValue=marketQuality();
      if(marketQualityValue>0)
      {
         ticket=OrderSend(Symbol(),OP_BUY,lotsi,Ask,slippage,0,0,"Ladder Long Order",MagicNumber,0,Blue);
         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
         else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue<0)
      {
         ticket=OrderSend(Symbol(),OP_SELL,lotsi,Bid,slippage,0,0,"Ladder Short Order",MagicNumber,0,Red);
         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
         else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue==0)
      {
        Print("No market to open"); 
      }
   }
   
   ticket=0;
   if(OpenOrders>=1 && ContinueOpening && lastType==1 && ((LastPrice-Ask)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_BUY,LastLots,Ask,slippage,0,0,"Ladder Long Order",MagicNumber,0,Blue);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
      //open another long position
   }
   
   if(OpenOrders>=1 && ContinueOpening && lastType==2 && ((Bid-LastPrice)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_SELL,LastLots,Bid,slippage,0,0,"Ladder Short Order",MagicNumber,0,Red);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
      //open another short position
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


